/**
    pasteboard.m
 
    Copyright (c) 2003 Stefan Urbanek
 
    Written by: Stefan Urbanek <urbanek@host.sk>
    Date: 2003 Oct 8
   
    This file is part of the ...
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02111, USA.
 
 */

#import <Foundation/NSAutoreleasePool.h>
#import <Foundation/NSData.h>
#import <Foundation/NSFileHandle.h>
#import <Foundation/NSException.h>
#import <Foundation/NSProcessInfo.h>
#import <Foundation/NSString.h>
#import <AppKit/NSPasteboard.h>

void copy_from_input(void)
{
    NSPasteboard *pboard = [NSPasteboard generalPasteboard];
    NSFileHandle *handle;
    NSString     *string;
    NSArray      *types;
    NSData       *data;

    handle = [NSFileHandle fileHandleWithStandardInput];

    data = [handle readDataToEndOfFile];
    string = [[NSString alloc] initWithData:data
                                   encoding:[NSString defaultCStringEncoding]];
    
    types = [NSArray arrayWithObjects:NSStringPboardType, nil];
    [pboard declareTypes:types owner:nil];
    [pboard addTypes:types owner:nil];
    [pboard setString:AUTORELEASE(string)
              forType:NSStringPboardType];
}
int main(int argc, const char **argv)
{	
    NSAutoreleasePool *pool;

    pool = [NSAutoreleasePool new];

    copy_from_input();

    RELEASE(pool);

    return 0;
}
